Index: trunk/SophyaLib/BaseTools/ndatablock.cc
===================================================================
--- trunk/SophyaLib/BaseTools/ndatablock.cc	(revision 261)
+++ trunk/SophyaLib/BaseTools/ndatablock.cc	(revision 265)
@@ -88,7 +88,8 @@
 //   NDataBlock A(5); A.FillFrom(5,x);
 {
-#ifdef DEBUG_NDATABLOCK
-cout<<"DEBUG_NDataBlock::Alloc("<<n<<") mSRef="<<mSRef<<endl;
-#endif
+    #ifdef DEBUG_NDATABLOCK
+    cout<<"DEBUG_NDataBlock::Alloc("
+        <<n<<","<<data<<","<<br<<") mSRef="<<mSRef<<endl;
+    #endif
 if(n==0) throw(SzMismatchError("NDataBlock::Alloc n==0\n"));
 if(mSRef) Delete();
@@ -98,10 +99,10 @@
 if(data) mSRef->data = data; else mSRef->data = new T[n];
 mSRef->bridge = br;
-#ifdef DEBUG_NDATABLOCK
-if(!data) NallocData++; NallocSRef++;
-cout<<"DEBUG_NDataBlock::Alloc("<<n<<") mSRef="<<mSRef
-    <<" mSRef->nref="<<mSRef->nref<<" mSRef->data="<< mSRef->data
-    <<" Total("<<NallocData<<","<<NallocSRef<<")"<<endl;
-#endif
+    #ifdef DEBUG_NDATABLOCK
+    if(!data) NallocData++; NallocSRef++;
+    cout<<"...DEBUG_NDataBlock::Alloc("<<n<<") mSRef="<<mSRef
+        <<" mSRef->nref="<<mSRef->nref<<" mSRef->data="<< mSRef->data
+        <<" Total("<<NallocData<<","<<NallocSRef<<")"<<endl;
+    #endif
 }
 
@@ -110,7 +111,8 @@
 // Clone (copie de donnee) a partir de "a"
 {
-#ifdef DEBUG_NDATABLOCK
-  cout<<"DEBUG_NDataBlock::Clone("<<&a<<")"<<endl;
-#endif
+    #ifdef DEBUG_NDATABLOCK
+    cout<<"DEBUG_NDataBlock::Clone("<<&a<<") a.mSz="
+        <<a.mSz<<" a.mSRef="<<a.mSRef<<" a.IsTemp="<<a.IsTemp()<<endl;
+    #endif
 if(!a.mSRef) {mSz=0; mSRef=NULL;} // cas ou "a" est cree par defaut
 else if(a.IsTemp()) Share(a);
@@ -122,7 +124,7 @@
 // Partage des donnees avec "a"
 {
-#ifdef DEBUG_NDATABLOCK
-cout<<"DEBUG_NDataBlock::Share("<<&a<<") a.mSRef="<<a.mSRef<<" mSRef="<<mSRef<<endl;
-#endif
+    #ifdef DEBUG_NDATABLOCK
+    cout<<"DEBUG_NDataBlock::Share("<<&a<<") a.mSRef="<<a.mSRef<<" mSRef="<<mSRef<<endl;
+    #endif
 if(&a==NULL) throw(NullPtrError("NDataBlock::Share  &a==NULL\n"));
 // on ne peut partager si "a" pas alloue
@@ -130,8 +132,8 @@
 if(mSRef) Delete();
 mSz = a.mSz; mSRef = a.mSRef; mSRef->nref++;
-#ifdef DEBUG_NDATABLOCK
-cout<<"DEBUG_...NDataBlock::Share("<<&a<<") mSRef="<<mSRef
-    <<" mSRef->nref="<<mSRef->nref<<" mSRef->data="<< mSRef->data<<endl;
-#endif
+    #ifdef DEBUG_NDATABLOCK
+    cout<<"...DEBUG_NDataBlock::Share("<<&a<<") mSRef="<<mSRef
+        <<" mSRef->nref="<<mSRef->nref<<" mSRef->data="<< mSRef->data<<endl;
+    #endif
 }
 
@@ -140,22 +142,23 @@
 // Pour detruire les pointeurs en tenant compte des references
 {
-#ifdef DEBUG_NDATABLOCK
-cout<<"DEBUG_NDataBlock::Delete() mSRef="<<mSRef;
-if(mSRef) cout<<" mSRef->nref="<<mSRef->nref<<" mSRef->data="<<mSRef->data;
-cout<<endl;
-#endif
+    #ifdef DEBUG_NDATABLOCK
+    cout<<"DEBUG_NDataBlock::Delete() mSRef="<<mSRef;
+    if(mSRef) cout<<" mSRef->nref="<<mSRef->nref<<" mSRef->data="<<mSRef->data;
+    cout<<endl;
+    #endif
 if(mSRef==NULL) return; // cas du createur par defaut
 mSRef->nref--;
 if(mSRef->nref != 0) {
-#ifdef DEBUG_NDATABLOCK
-  cout<<"DEBUG_...NDataBlock::Delete() pas de desallocation il reste nref="<<mSRef->nref<<endl;
-#endif
+    #ifdef DEBUG_NDATABLOCK
+      cout<<"...DEBUG_NDataBlock::Delete() pas de desallocation il reste nref="
+          <<mSRef->nref<<endl;
+    #endif
   return;
 }
-#ifdef DEBUG_NDATABLOCK
-if(!mSRef->bridge) NallocData--; NallocSRef--;
-cout<<"DEBUG_...NNDataBlock::Delete() desallocation complete il reste nref="<<mSRef->nref
-    <<" Total("<<NallocData<<","<<NallocSRef<<")"<<endl;
-#endif
+    #ifdef DEBUG_NDATABLOCK
+    if(!mSRef->bridge) NallocData--; NallocSRef--;
+    cout<<"...DEBUG_NDataBlock::Delete() desallocation complete il reste nref="
+        <<mSRef->nref<<" Total("<<NallocData<<","<<NallocSRef<<")"<<endl;
+    #endif
 // Si il y a un Bridge les donnees ne n'appartiennent pas, on detruit le Bridge
 if(mSRef->bridge) delete mSRef->bridge; 
@@ -226,5 +229,6 @@
 {
 if(this == &a) return *this;
-if(a.mSz!=mSz) throw(SzMismatchError("NDataBlock::operator=A size mismatch/null\n"));
+if(a.mSz!=mSz)
+  throw(SzMismatchError("NDataBlock::operator=A size mismatch/null\n"));
 Share(a);
 return *this;
@@ -287,5 +291,6 @@
 NDataBlock<T>& NDataBlock<T>::operator += (NDataBlock<T>& a)
 {
-if(mSz==0 || mSz!=a.mSz) throw(SzMismatchError("NDataBlock::operator+=A size mismatch/null"));
+if(mSz==0 || mSz!=a.mSz)
+  throw(SzMismatchError("NDataBlock::operator+=A size mismatch/null"));
 T *p=Begin(), *pe=End(), *pa=a.Begin();
 while (p<pe) *p++ += *pa++; // ca marche meme si *this=a
@@ -296,5 +301,6 @@
 NDataBlock<T>& NDataBlock<T>::operator -= (NDataBlock<T>& a)
 {
-if(mSz==0 || mSz!=a.mSz) throw(SzMismatchError("NDataBlock::operator-=A size mismatch/null"));
+if(mSz==0 || mSz!=a.mSz)
+  throw(SzMismatchError("NDataBlock::operator-=A size mismatch/null"));
 T *p=Begin(), *pe=End(), *pa=a.Begin();
 while (p<pe) *p++ -= *pa++; // ca marche meme si *this=a
@@ -305,5 +311,6 @@
 NDataBlock<T>& NDataBlock<T>::operator *= (NDataBlock<T>& a)
 {
-if(mSz==0 || mSz!=a.mSz) throw(SzMismatchError("NDataBlock::operator*=A size mismatch/null"));
+if(mSz==0 || mSz!=a.mSz)
+  throw(SzMismatchError("NDataBlock::operator*=A size mismatch/null"));
 T *p=Begin(), *pe=End(), *pa=a.Begin();
 while (p<pe) *p++ *= *pa++; // ca marche meme si *this=a
@@ -314,5 +321,6 @@
 NDataBlock<T>& NDataBlock<T>::operator /= (NDataBlock<T>& a)
 {
-if(mSz==0 || mSz!=a.mSz) throw(SzMismatchError("NDataBlock::operator/=A size mismatch/null"));
+if(mSz==0 || mSz!=a.mSz)
+  throw(SzMismatchError("NDataBlock::operator/=A size mismatch/null"));
 T *p=Begin(), *pe=End(), *pa=a.Begin();
 while (p<pe) *p++ /= *pa++;
@@ -388,5 +396,6 @@
 {
 NDataBlock<T>& a = *this;
-if(a.mSz!=b.mSz) throw(SzMismatchError("NDataBlock operator C=A+B size mismatch/null\n"));
+if(a.mSz!=b.mSz)
+  throw(SzMismatchError("NDataBlock operator C=A+B size mismatch/null\n"));
 if(b.IsTemp()) {
   NDataBlock<T> result(b,true); result.SetTemp(true);
@@ -403,5 +412,6 @@
 {
 NDataBlock<T>& a = *this;
-if(a.mSz!=b.mSz) throw(SzMismatchError("NDataBlock operator C=A*B size mismatch/null\n"));
+if(a.mSz!=b.mSz)
+  throw(SzMismatchError("NDataBlock operator C=A*B size mismatch/null\n"));
 if(b.IsTemp()) {
   NDataBlock<T> result(b,true); result.SetTemp(true);
@@ -418,5 +428,6 @@
 {
 NDataBlock<T>& a = *this;
-if(a.mSz!=b.mSz) throw(SzMismatchError("NDataBlock operator C=A-B size mismatch/null\n"));
+if(a.mSz!=b.mSz)
+  throw(SzMismatchError("NDataBlock operator C=A-B size mismatch/null\n"));
 if(b.IsTemp()) {
   NDataBlock<T> result(b,true); result.SetTemp(true);
@@ -435,5 +446,6 @@
 {
 NDataBlock<T>& a = *this;
-if(a.mSz!=b.mSz) throw(SzMismatchError("NDataBlock operator C=A/B size mismatch/null\n"));
+if(a.mSz!=b.mSz)
+  throw(SzMismatchError("NDataBlock operator C=A/B size mismatch/null\n"));
 if(b.IsTemp()) {
   NDataBlock<T> result(b,true); result.SetTemp(true);
Index: trunk/SophyaLib/BaseTools/ndatablock.h
===================================================================
--- trunk/SophyaLib/BaseTools/ndatablock.h	(revision 261)
+++ trunk/SophyaLib/BaseTools/ndatablock.h	(revision 265)
@@ -119,5 +119,5 @@
 template<class T>
 inline NDataBlock<T> operator + (NDataBlock<T>& a,NDataBlock<T>& b)
-                     {return a.Add(b);}
+                      {return a.Add(b);}
 template<class T>
 inline NDataBlock<T> operator - (NDataBlock<T>& a,NDataBlock<T>& b)